﻿using System;

namespace _01_IntroKlassen
{
    class Personalausweis
    {
        private string name;
        // public int persoId { get; private set; }
        private int _persoId;
        public int persoId
        {
            get { return _persoId; }
            private set { _persoId = value; }
        }
        private static int naechsteID = 1000; 
        // static: Dieses Datenfeld gibt es nur EINMAL für die Klasse

        // KEIN static vor dem Methodennamen ==>
        // Die Methode hat eine automatische this-Referenz
        public Personalausweis(string name)
        {
            this.name = name;
            this.persoId = naechsteID;
            naechsteID++;
        }
        //public override string ToString()
        //    => $"Name: {name}, Perso-Id: {persoId}";
        public string getName() { return name; }
        public int Id { get => persoId; }
        public void setNaechsteId(int wert)
        {
            if (wert < naechsteID)
                throw new ArgumentOutOfRangeException("Die neue ID darf nicht kleiner als die Aktuelle sein!");
            naechsteID = wert;
        }

        public static int NaechsteID
        {
            get { Console.WriteLine("get()  "); return naechsteID; }
            set
            {
                Console.WriteLine($"set({value})  ");
                if (value < naechsteID)
                    throw new ArgumentOutOfRangeException("Die neue ID darf nicht kleiner als die Aktuelle sein!");
                naechsteID = value;
            }
        }
    }
    class Buergeramt
    {
        private Personalausweis[] personalausweise;
        private int anzPersos=0;
        public Buergeramt(int anz=1000)
        {
            personalausweise = new Personalausweis[anz];
        }
        public void NeuerPersonalausweis(Personalausweis perso)
        {
            personalausweise[anzPersos] = perso;
            anzPersos++;
        }
        public Personalausweis getPerso(int n)
        {
            return personalausweise[n];
        }
        public Personalausweis this [int n]
        {
            get => personalausweise[n];
        }
        public Personalausweis this[string name]
        {
            get
            {
                for (int i = 0; i < personalausweise.Length; i++)
                {
                    if (personalausweise[i].getName() == name)
                        return personalausweise[i];
                }
                return null;

            }
            
        }
    }
    
    
    class Program
    {
        int mal2(int x) => x * 2;
        static void Main(string[] args)
        {
            Buergeramt nuernberg = new Buergeramt(2000);
            Buergeramt fuerth = new Buergeramt();
            nuernberg.NeuerPersonalausweis(new Personalausweis("Anton"));
            fuerth.NeuerPersonalausweis(new Personalausweis("Berta"));
            Console.WriteLine(nuernberg.getPerso(0));
            Console.WriteLine(nuernberg[0]);
            Console.WriteLine(nuernberg["Anton"]);
        }
        static void Main2(string[] args)
        {
            Personalausweis.NaechsteID = 10000;

            Personalausweis anton = new Personalausweis("Anton");
            Personalausweis berta = new Personalausweis("Berta");
            Console.WriteLine(anton);
            Console.WriteLine(berta);
            Console.WriteLine(anton.getName());
            Console.WriteLine(anton.Id);
            int x = anton.Id;
            //anton.Id = 444;

            Personalausweis.NaechsteID ++;
            Personalausweis claudia = new Personalausweis("Claudia");
            Console.WriteLine(claudia);
        }
    }
}
