﻿using System;

namespace _01_UebgDi_KlasseMitStaticKonstruktor
{
    // Programmieren Sie eine Klasse Kennzeichen mit folgenden privaten Eigenschaften
    // string kennzeichen
    // int position

    // - statischer Konstruktor: Erzeugt ein Feld (statisch/nicht-statisch)
    //    von verfügbaren Kennzeichen.

    // - Konstruktor: Nimmt das nächste verfügbare Kennzeichen aus dem Feld und initialisiert das Objekt damit. Dann wird das
    //      betreffende Kennzeichen im Kennzeichenfeld gelöscht (=null). In der position-Variablen wird die Feldnummer gespeichert.

    // - Methode: Kennzeichenzurückgeben: Erhält ein Kennzeichen und schreibt dieses Kennzeichen dann wieder in das Kennzeichenfeld
    //      an die betreffende Position zurück.

    class Kennzeichen
    {
        const int anz = 20;
        const string kuerzel = "N - AB - ";
        public string kennzeichen { get; private set; }
        int position;

        static string[] kennzFeld;
        static Kennzeichen()
        {
            Console.WriteLine("Static Konstruktor");
            kennzFeld = new string[anz];
            for (int i = 0; i < anz; i++)
                kennzFeld[i] = $"{kuerzel}{100 + i}";
        }
        public Kennzeichen()
        {
            Console.WriteLine("Nicht-Static Konstruktor");
            for (int i = 0; i < anz; i++)
            {
                if (kennzFeld[i] != null)
                {
                    kennzeichen = kennzFeld[i];
                    position = i;
                    kennzFeld[i] = null;
                    return;
                }
            }
            throw new Exception("Keine Kennzeichen mehr verfügbar");
        }
        public void KennzeichenZurueckgeben()
        {
            kennzFeld[position] = kennzeichen;
            kennzeichen = null;
        }
        public override string ToString() => $"{kennzeichen},  pos: {position}";
    }
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Vor erstem new");
            Kennzeichen k1 = new Kennzeichen();
            Kennzeichen k2 = new Kennzeichen();
            Kennzeichen k3 = new Kennzeichen();

            k2.KennzeichenZurueckgeben();

            Console.WriteLine(k1);
            Console.WriteLine(k2);
            Console.WriteLine(k3);

            Console.WriteLine("------");
            k2 = new Kennzeichen();
            Console.WriteLine(k2);

        }
    }
}
