﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _02_OperatorUeberladgBrueche
{
    class Bruch
    {
        int z, n;
        public Bruch(int Z, int N = 1)
        {
            z = Z;
            n = N;
        }
        public Bruch(string s)
        {
            string[] d = s.Split('/');
            z = Convert.ToInt32(d[0]);
            n = Convert.ToInt32(d[1]);
        }
        public override string ToString() => $"{z}/{n}";

        #region Binäre Operatoren
        public void Mult_V1(Bruch b2)
        {
            z = z * b2.z;
            n = n * b2.n;
        }
        public Bruch Mult_V2(Bruch b2)
        {
            return new Bruch(z * b2.z, n * b2.n);
        }
        public Bruch Mult_V3(Bruch b2) => new Bruch(z * b2.z, n * b2.n);
        public static Bruch operator *(Bruch b1, Bruch b2) => new Bruch(b1.z * b2.z, b1.n * b2.n);
        public static Bruch operator +(Bruch b1, Bruch b2) => new Bruch(b1.z * b2.n + b2.z * b1.n, b1.n * b2.n);
        //public static Bruch operator *(Bruch b1, int k) => new Bruch(b1.z * k, b1.n);
        //public static Bruch operator *(int k, Bruch b1) => new Bruch(b1.z * k, b1.n);
        #endregion

        #region Konvertierungsoperatoren
        public static implicit operator Bruch(int k) => new Bruch(k);
        // Konvertiert einen Int in einen Bruch
        public static explicit operator int(Bruch b) => b.z / b.n;
        // Konvertiert einen Bruch in einen int. Da ein Genauigkeitsverlust
        // möglich ist: explicit
        public static implicit operator Bruch(string s) => new Bruch(s);
        #endregion

        #region Unäre Operatoren
        public static Bruch operator +(Bruch b) => b;
        public static Bruch operator -(Bruch b) => new Bruch(-b.z, b.n);

        // x = 5; cw(x++)--> cw(x); x=x+1  ,  cw(++x) --> x=x+1;cw(x)
        // b1++    3/2++  --> 5/2
        // Compiler generiert selbstätig die entsprechende Codeanordnung
        public static Bruch operator ++(Bruch b) => new Bruch(b.z + b.n, b.n);
        public static Bruch operator --(Bruch b) => new Bruch(b.z - b.n, b.n);
        #endregion

        #region Vergleichsoperatoren
        public static bool operator ==(Bruch b1, Bruch b2) => b1.z == b2.z && b1.n == b2.n;
        public static bool operator !=(Bruch b1, Bruch b2) => !(b1 == b2);
        public override bool Equals(object obj)
        {
            if (obj == null)
                return false;
            if (this.GetType() != obj.GetType())
                return false;

            return this == (Bruch)obj;
        }
        public override int GetHashCode()
        {
            return z.GetHashCode() ^ n.GetHashCode();
        }

        public static bool operator true(Bruch b) => b.n != 1;
        public static bool operator false(Bruch b) => b.n == 1;
        #endregion
    }
}
