﻿using System;

namespace _10_IntroDelegates
{
    class Program
    {
        delegate double MyFunction(double x);
        // MyFunction ist Stellvertreter für alle Funktionen/Methoden,
        // die genau ein double als Eingangsparameter besitzen und ein
        // double als Returnwert liefern
        static void Wertetabelle(double von, double bis, MyFunction fkt)
        {
            for (double x = von; x <= bis; x += 1)
                Console.WriteLine($"{x,6:f2} | {fkt(x)}");
            Console.WriteLine("------------------");
        }

        // ----------------- FIRMA A ------------------

        // ----------------- FIRMA B ------------------

        static MyFunction fkt;
        static void Wertetabelle2(double von, double bis)
        {
            for (double x = von; x <= bis; x += 1)
                Console.WriteLine($"{x,6:f2} | {fkt(x)}");
            Console.WriteLine("------------------");
        }
        static double Quadrat(double x) { return x * x; }
        static double Mal2(double x) => 2 * x;
        static void Main(string[] args)
        {
            Wertetabelle(1, 6, Quadrat);
            Wertetabelle(1, 6, Mal2);
            Wertetabelle(1, 6, Math.Sin);
            Wertetabelle(1, 6, delegate (double x) { return 3 * x; });
            // Anonyme Methode
            Wertetabelle(1, 6, x => 4 * x );
            // Lambda Methode


            // Delegate-Objekte sind "Variablen", denen Funktionsreferenzen
            // als Werte zugewiesen werden können
            Console.WriteLine("****************");
            //fkt = Quadrat;
            fkt = delegate (double x) { return 3 * x; };
            Wertetabelle2(1, 3);

            // Dabei kann mit += auch mehr als eine Funktionsreferenz in
            // der Delegatevariablen gespeichert werden
            fkt += Math.Sin;
            Wertetabelle2(1, 3);
        }
    }
}
