﻿using System;
using System.Collections.Generic;

namespace _11_ApplyAll
{
    /* Schreiben Sie die folgenden generischen Methoden:
     * 
     * 1) ApplyAll, die für Felder eines beliebigen Typs, eine übergebene Funktion auf alle Feldelemente anwendet
     * und das derart modifizierte Feld zurückliefert.
     * 
     * 2) Select soll eine übergebene Filterfunktion auf alle Feldelemente anwenden und nur diejenigen zurückliefern,
     * bei denen das Feldelement die Filterkriterien erfüllt. 
     * Hierfür kann die generische MS Liste<> verwendet werden.
     * 
     * Schreiben Sie für unterschiedliche Basistypen Lambda-Ausdrücke oder anonyme Methoden
     */
    class Program
    {
        delegate K MyFunction<K>(K x);
        static T[] ApplyAll<T>(MyFunction<T> f, params T[] arr)
        {
            T[] erg = new T[arr.Length];
            for (int i = 0; i < arr.Length; i++)
            {
                erg[i] = f(arr[i]);
                Console.Write(erg[i] + "  ");
            }
            Console.WriteLine();
            return erg;
        }
        static T[] Select<T>(Predicate<T> filter, params T[] arr)
        {
            List<T> erg = new List<T>();
            for (int i = 0; i < arr.Length; i++)
            {
                if (filter(arr[i]))
                {
                    erg.Add(arr[i]);
                    Console.Write(arr[i] + "  ");
                }
            }
            Console.WriteLine();
            return erg.ToArray();
        }
        static int Quadrat(int x) { return x * x; }
        static void Main(string[] args)
        {



            ApplyAll(x => x * x, 1, 2, 3, 4, 5, 6);
            ApplyAll(Quadrat, 1, 2, 3, 4, 5, 6);
            ApplyAll(delegate (int x) { return x * 2; },
                1, 2, 3, 4, 5, 6);
            ApplyAll(x => x.ToUpper(), "Hallo", "Welt");
            Select(s => s.Contains("er"), "Anton", "Berta", "Claudia", "Dieter");
            Select(s => s.Length>5, "Anton", "Berta", "Claudia", "Dieter");
            ApplyAll(s=>s.Length.ToString(),Select(s => s.Length > 5, "Anton", "Berta", "Claudia", "Dieter"));
        }
    }
}
