﻿using System;

namespace _11_DelegatePipelining
{
    delegate void myAction(ref string s);
    class Pipeline
    {
        public event myAction transform;

        public string Bearbeiten(string s)
        {
            transform?.Invoke(ref s);
            return s;
        }
    }
    class Program
    {
        static void Grossbuchstaben(ref string s)
        {
            s = s.ToUpper();
            Console.WriteLine($"Grossbuchstaben: {s}");
        }
        static void Rest(ref string s)
        {
            s = s.Substring(6);
            Console.WriteLine($"Rest: {s}");
        }
        static void Main(string[] args)
        {
            Pipeline pl = new Pipeline();
            pl.transform += Grossbuchstaben;
            pl.transform += Rest;

            string erg = pl.Bearbeiten("Hallo Welt");
            Console.WriteLine($"Final: {erg}");
        }
    }
}
