﻿using System;
using System.Collections.Generic;
using System.Text;

namespace _11_5_BinTreePersVerwaltung
{
    abstract class Personal : IComparable<Personal>
    {
        public virtual string Name { get; set; }

        //private string Name2x;
        //public string Name2
        //{
        //    get { return Name2x; }
        //    set { Name2x = value; }
        //}
        public Personal (string Name) { this.Name = Name; }
        abstract public double Kosten { get; }
        public int CompareTo(Personal other) => Name.CompareTo(other.Name);
    }
    class Mitarbeiter : Personal 
    {
        protected double gehalt;
        public Mitarbeiter(string Name, double Gehalt) : base(Name) { gehalt = Gehalt; }
        public override double Kosten { get => 12.65 * gehalt; }
        public override string ToString() => $"{Name,-15} {Kosten,6}";
    }
    class Führungskraft : Personal 
    {
        protected double gehalt;
        protected double erfolgsbeteiligung;
        public Führungskraft (string Name, double Gehalt, double Erfolgsbeteiligung) : base (Name)
        {
            gehalt = Gehalt;
            erfolgsbeteiligung = Erfolgsbeteiligung;
        }
        public override double Kosten { get => 12.65 * gehalt + erfolgsbeteiligung; }
        public override string ToString() => $"{Name,-15} {Kosten,6}";
    }
    class Werkvertragler : Personal 
    {
        protected double betrag;
        public Werkvertragler(string Name, double Betrag) : base (Name)
        {
            betrag = Betrag;
        }
        public override double Kosten { get => betrag; }
        public override string ToString() => $"{Name,-15} {Kosten,6}";
    }
}
