﻿using System;
using System.Linq;

namespace _11_6_ListPersVerwaltung
{
    class Program
    {
        static void InputData(MyList<Personal> pt)
        {
            pt.AddSorted(new Mitarbeiter("Dieter", 2000));
            pt.AddSorted(new Führungskraft("Anton", 5000, 10000));
            pt.AddSorted(new Werkvertragler("Gustav", 12000));
            pt.AddSorted(new Mitarbeiter("Heiner", 2000));
            pt.AddSorted(new Werkvertragler("Berta", 10000));
            pt.AddSorted(new Werkvertragler("Ludwig", 12000));
            pt.AddSorted(new Mitarbeiter("Klaus", 2000));
            pt.AddSorted(new Mitarbeiter("Ida", 2000));
            pt.AddSorted(new Führungskraft("Charles", 5000, 10000));
            pt.AddSorted(new Werkvertragler("Johanna", 10000));
            pt.AddSorted(new Mitarbeiter("Emma", 2000));
            pt.AddSorted(new Mitarbeiter("Franz", 10000));
            pt.AddSorted(new Werkvertragler("Norbert", 10000));
            pt.AddSorted(new Werkvertragler("Willi", 10000));
            pt.AddSorted(new Mitarbeiter("Quasimodo", 2500));
            pt.AddSorted(new Führungskraft("Manni", 5200, 15000));
            pt.AddSorted(new Mitarbeiter("Otto", 10000));
            pt.AddSorted(new Werkvertragler("Uwe", 10000));
            pt.AddSorted(new Werkvertragler("Stefan", 10000));
            pt.AddSorted(new Mitarbeiter("Thorsten", 10000));
            pt.AddSorted(new Werkvertragler("Rainer", 10000));
            pt.AddSorted(new Werkvertragler("Zacharias", 10000));
            pt.AddSorted(new Mitarbeiter("Yvonne", 3000));
            pt.AddSorted(new Führungskraft("Volker", 5100, 10000));
            pt.AddSorted(new Mitarbeiter("Xaver", 2500));
            pt.AddSorted(new Werkvertragler("Paul", 15000));
        }
        static void Main(string[] args)
        {

            MyList<Personal> persListe = new MyList<Personal>();
            InputData(persListe);
            persListe.Print();
            Console.WriteLine("-------------------");


            var res = from Personal p in persListe
                      where p is Führungskraft
                      orderby p.Kosten descending
                      select new { Name = p.Name.ToUpper(), Kosten = p.Kosten };
            foreach (var item in res)
            {
                Console.WriteLine(item);
            }
            Console.WriteLine("-------------------");

            double GesKosten = res.Sum(w => w.Kosten);
            Console.WriteLine("Kosten für die Führungskräfte: " + GesKosten);

            int anz = res.Count();
            Console.WriteLine(anz + " Führungskräfte");
            Console.WriteLine("-------------------");


            var res2 = from Personal p in persListe
                       where p.Kosten < 30000
                       orderby p.Kosten descending, p.Name ascending // Sortierung nach Kosten, dann Name
                       select new { Name = p.Name, K = p.Kosten };
            foreach (var item in res2)
                Console.WriteLine(item.Name + ": " + item.K);
        }
    }
}
